LapStore.Web/Areas/Admin/Controllers/PostsController.cs
using LapStore.Common;
using LapStore.Core.Infrastructures;
using LapStore.Core.Models;
using LapStore.ModelViews.PostViewModel;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace LapStore.Web.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = SD.Role_Admin)]
    public class PostsController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;

        public PostsController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        public IActionResult Index()
        {
           
            return View();
        }

        //GET
       
        public IActionResult Create()
        {
            ViewBag.CategoryList = _unitOfWork.CategoryRepository.GetAll().Select(i => new SelectListItem
            {
                Text = i.Name,
                Value = i.Id.ToString()
            });
            ViewBag.PublishedList = new List<SelectListItem>()
            {
                new SelectListItem() { Text = "True", Value = true.ToString(), Selected=true },
                new SelectListItem() { Text = "False", Value = false.ToString(), Selected=false },
            };
           
            return View();
        }

        //POST
        [HttpPost]
        [ValidateAntiForgeryToken]
        
        public IActionResult Create(CreatePostVM request)
        {
           
            if (ModelState.IsValid)
            {
                //1. add tag vao database
                var tagIds = this._unitOfWork.TagRepository.AddTagByString(request.Tags);
                // 2. create postTag
                var postTags = new List<PostTagMap>();
                foreach (var tagId in tagIds)
                {
                    var postTag = new PostTagMap()
                    {
                        TagId = tagId
                    };
                    postTags.Add(postTag);
                }
                var post = new Post()
                {
                    Title = request.Title,
                    UrlSlug = SeoUrlHepler.FrientlyUrl(request.Title),
                    PostContent = request.PostContent,
                    CategoryId = request.CategoryId,
                    ShortDescription = request.ShortDescription,
                    PostTagMap = postTags
                };
                this._unitOfWork.PostRepository.Add(post);
                _unitOfWork.SaveChange();
                TempData["success"] = "Post created successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Post created error";
            ViewBag.CategoryList = _unitOfWork.CategoryRepository.GetAll().Select(i => new SelectListItem
            {
                Text = i.Name,
                Value = i.Id.ToString()
            });
            ViewBag.PublishedList = new List<SelectListItem>()
            {
                new SelectListItem() { Text = "True", Value = true.ToString(), Selected=true },
                new SelectListItem() { Text = "False", Value = false.ToString(), Selected=false },
            };
            return View(request);
        }

        //GET
        public IActionResult Edit(int? id)
        {

            if (id.Value == null || id.Value == 0)
            {
                return NotFound();
            }
            var PostFromDbFirst = _unitOfWork.PostRepository.GetById(id.Value);
            if (PostFromDbFirst == null)
            {
                return NotFound();
            }
            UpdatePostVM updatePostVM = new UpdatePostVM()
            {
                Post = PostFromDbFirst,
                CategoryList = new SelectList(_unitOfWork.CategoryRepository.GetAll(), "Id", "Name", PostFromDbFirst.CategoryId),
                TagList =string.Join("; ", _unitOfWork.TagRepository.GetTagsByPost(id.Value).Select(x=>x.Name)) 
            };
            ViewBag.PublishedList = new List<SelectListItem>()
            {
                new SelectListItem() { Text = "True", Value = true.ToString(), Selected=true },
                new SelectListItem() { Text = "False", Value = false.ToString(), Selected=false },
            };
            return View(updatePostVM);
        }

        //POST
        [HttpPost]
        [ValidateAntiForgeryToken]
        
        public IActionResult Edit(UpdatePostVM obj)
        {
           
            if (ModelState.IsValid)
            {
                //1. add tag vao database
                var tagIds = this._unitOfWork.TagRepository.AddTagByString(obj.TagList);
               //2. delete post tag
              var postTagDeletes= _unitOfWork.LapStoreContext.PostTagMap.Where(x => x.PostId == obj.Post.Id);
                foreach (var postTagMap in postTagDeletes)
                {
                    _unitOfWork.LapStoreContext.PostTagMap.Remove(postTagMap);
                }
                _unitOfWork.SaveChange();
                // 3. create postTag
                var postTags = new List<PostTagMap>();
                foreach (var tagId in tagIds)
                {
                    var postTag = new PostTagMap()
                    {
                        PostId= obj.Post.Id,
                        TagId = tagId
                    };
                    postTags.Add(postTag);
                }
                _unitOfWork.LapStoreContext.PostTagMap.AddRange(postTags);
                obj.Post.PostTagMap = postTags;
                obj.Post.UrlSlug = SeoUrlHepler.FrientlyUrl(obj.Post.Title);
                _unitOfWork.PostRepository.Update(obj.Post);
                _unitOfWork.SaveChange();
                TempData["success"] = "Post updated successfully";
                return RedirectToAction("Index");
            }
            obj.CategoryList = new SelectList(_unitOfWork.CategoryRepository.GetAll(), "Id", "Name", obj.Post.CategoryId);
            TempData["error"] = "Post Edit error";
            return View(obj);
        }

      

        #region API CALLS
        [HttpGet]
        public IActionResult GetAll(string status)
        {
            var productList = _unitOfWork.PostRepository.GetAll(includeProperties:"Category");
            switch (status)
            {
                case "latest":
                    productList = _unitOfWork.PostRepository.GetLatestPost(10);
                    break;
                case "mostViewed":
                    productList = _unitOfWork.PostRepository.GetMostViewedPost(10);
                    break;
                case "mostInteresting":
                    productList = _unitOfWork.PostRepository.GetHighestPosts(10);
                    break;
                case "published":
                    productList = _unitOfWork.PostRepository.GetPublisedPosts();
                    break;
                case "unPublished":
                    productList = _unitOfWork.PostRepository.GetUnpublisedPosts();
                    break;
                default:
                    break;
            }
            return Json(new { data = productList });
        }
        [Authorize(Roles = SD.Role_Admin)]
        //POST
        [HttpDelete]
        public IActionResult Delete(int? id)
        {
            var obj = _unitOfWork.PostRepository.GetById(id.Value);
            if (obj == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            _unitOfWork.PostRepository.Delete(obj);
            _unitOfWork.SaveChange();
            return Json(new { success = true, message = "Delete Successful" });

        }
       
      
        [HttpPost]
        public JsonResult AutoComplete(string Prefix)
        {
            var names = _unitOfWork.TagRepository.GetAll().Where(p => p.Name.Contains(Prefix)).Select(p => p.Name).ToList();

            return Json(names);
        }
        #endregion

    }
}

LapStore.Web/Areas/Admin/Controllers/ProductsController.cs
using LapStore.Common;
using LapStore.Core.Infrastructures;
using LapStore.Core.Models;
using LapStore.ModelViews.PostViewModel;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace LapStore.Web.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = SD.Role_Admin)]
    public class ProductsController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;

        public ProductsController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        public IActionResult Index()
        {
            return View();
        }

        //GET
        public IActionResult Create()
        {
            ViewBag.CategoryList = _unitOfWork.BrandRepository.GetAll().Select(i => new SelectListItem
            {
                Text = i.Name,
                Value = i.Id.ToString()
            });
            return View();
        }

        //Product
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(Product request)
        {

            if (ModelState.IsValid)
            {
                request.UrlSlug = SeoUrlHepler.FrientlyUrl(request.Name);
                this._unitOfWork.ProductRepository.Add(request);
                _unitOfWork.SaveChange();
                TempData["success"] = "Product created successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Product created error";
            return View(request);
        }

        //GET
        public IActionResult Edit(int? id)
        {

            ViewBag.CategoryList = _unitOfWork.BrandRepository.GetAll().Select(i => new SelectListItem
            {
                Text = i.Name,
                Value = i.Id.ToString()
            });
            
            if (id.Value == null || id.Value == 0)
            {
                return NotFound();
            }
            var ProductFromDbFirst = _unitOfWork.ProductRepository.GetById(id.Value);
            if (ProductFromDbFirst == null)
            {
                return NotFound();
            }

            return View(ProductFromDbFirst);
        }

        //Product
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(Product obj)
        {

            if (ModelState.IsValid)
            {
                obj.UrlSlug = SeoUrlHepler.FrientlyUrl(obj.Name);
                _unitOfWork.ProductRepository.Update(obj);
                _unitOfWork.SaveChange();
                TempData["success"] = "Product updated successfully";
                return RedirectToAction("Index");
            }
            TempData["error"] = "Product created error";
            return View(obj);
        }



        #region API CALLS
        [HttpGet]
        public IActionResult GetAll(string status)
        {
            var productList = _unitOfWork.ProductRepository.GetAll();
            return Json(new { data = productList });
        }


        //Product
        [HttpDelete]
        [Authorize(Roles = SD.Role_Admin)]
        public IActionResult Delete(int? id)
        {
            var obj = _unitOfWork.ProductRepository.GetById(id.Value);
            if (obj == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            _unitOfWork.ProductRepository.Delete(obj);
            _unitOfWork.SaveChange();
            return Json(new { success = true, message = "Delete Successful" });

        }
        #endregion

    }
}

LapStore.Web/Areas/Customer/Controllers/ProductsController.cs
using LapStore.Core.Infrastructures;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using X.PagedList;

namespace LapStore.Web.Areas.Customer.Controllers
{
    [Area("Customer")]
    public class ProductsController : Controller
    {
        private readonly IUnitOfWork unitOfWork;

        public ProductsController( IUnitOfWork unitOfWork)
        {
            this.unitOfWork = unitOfWork;
        }

        public IActionResult Index(string search="",int? page = 1)
        {
            if (page != null && page < 1)
            {
                page = 1;
            }

            var pageSize = 6;
            if (search == null) {
                var listProduct = unitOfWork.ProductRepository.GetAll().ToPagedList(page ?? 1, pageSize);

                return View(listProduct);
            }
            else
            {
                var listProduct = unitOfWork.ProductRepository.GetAll().Where(x => x.Name.Contains(search)).ToPagedList(page ?? 1, pageSize);

                return View(listProduct);
            }

        }
        public IActionResult Detail(int id)
        {
            var Product = unitOfWork.ProductRepository.GetById(id);
            return View(Product);
        }
        public IActionResult Details(int id)
        {
            var Product = unitOfWork.ProductRepository.GetById(id);
            if (Product == null)
                return NotFound();
            unitOfWork.ProductRepository.Update(Product);
            unitOfWork.SaveChange();
            return View(Product);
        }
        public IActionResult GetProductByBrand(string brandUrl, string search = "", int? page = 1)
        {
            if (page != null && page < 1)
            {
                page = 1;
            }

            var pageSize = 6;
            if (search == null)
            {
                var listProduct = unitOfWork.ProductRepository.GetAll(includeProperties: "Brand").Where(x=>x.Brand.UrlSlug.Equals(brandUrl)).ToPagedList(page ?? 1, pageSize);

                return View("Index",listProduct);
            }
            else
            {
                var listProduct = unitOfWork.ProductRepository.GetAll(includeProperties: "Brand").Where(x => x.Brand.UrlSlug.Equals(brandUrl)).Where(x => x.Name.Contains(search)).ToPagedList(page ?? 1, pageSize);

                return View("Index",listProduct);
            }
        }

    }
}

LapStore.Web/Areas/Admin/Views/Products/Create.cshtml
@model Product
@{
    ViewData["Title"] = "";
    Layout = "~/Views/Shared/_LayoutAdmin.cshtml";
	
}

<form method="post"  asp-action="Create" style="width:90%; margin: 0 auto;" enctype="multipart/form-data">
	<div class="border p-3 mt-4" >
		<div class="row pb-6">
			<h2 class="text-primary">Thêm mới</h2>
			<hr />
		</div>
		@*<div asp-validation-summary="All"></div>*@
           <div class="mb-3">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="ImageName" class="control-label"></label>
                <input asp-for="ImageName" class="form-control" />
                <span asp-validation-for="ImageName" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="MoreImages" class="control-label"></label>
                <input asp-for="MoreImages" class="form-control" />
                <span asp-validation-for="MoreImages" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Monitor" class="control-label"></label>
                <input asp-for="Monitor" class="form-control" />
                <span asp-validation-for="Monitor" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Cpu" class="control-label"></label>
                <input asp-for="Cpu" class="form-control" />
                <span asp-validation-for="Cpu" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Ram" class="control-label"></label>
                <input asp-for="Ram" class="form-control" />
                <span asp-validation-for="Ram" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="HardDriver" class="control-label"></label>
                <input asp-for="HardDriver" class="form-control" />
                <span asp-validation-for="HardDriver" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Card" class="control-label"></label>
                <input asp-for="Card" class="form-control" />
                <span asp-validation-for="Card" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="OperatingSystem" class="control-label"></label>
                <input asp-for="OperatingSystem" class="form-control" />
                <span asp-validation-for="OperatingSystem" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Weight" class="control-label"></label>
                <input asp-for="Weight" class="form-control" />
                <span asp-validation-for="Weight" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Size" class="control-label"></label>
                <input asp-for="Size" class="form-control" />
                <span asp-validation-for="Size" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Quantity" class="control-label"></label>
                <input asp-for="Quantity" class="form-control" />
                <span asp-validation-for="Quantity" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="RateCount" class="control-label"></label>
                <input asp-for="RateCount" class="form-control" />
                <span asp-validation-for="RateCount" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="TotalRate" class="control-label"></label>
                <input asp-for="TotalRate" class="form-control" />
                <span asp-validation-for="TotalRate" class="text-danger"></span>
            </div>
		<div class="mb-3">
			<label asp-for="BrandId">Category</label>
			<select asp-for="BrandId" asp-items="@ViewBag.CategoryList" class="form-control">
				<option disabled selected>--Select CoverType--</option>
			</select>
			<span asp-validation-for="BrandId" class="text-danger"></span>
		</div>
		<button type="submit" class="btn btn-primary" style="width:150px">Create</button>
		<a asp-controller="Posts" asp-action="Index" class="btn btn-secondary" style="width:150px">
			Back to List
		</a>
	</div>
</form>

@section Scripts{
	@{
		<partial name="_ValidationScriptsPartial" />
	}
	<script>
    tinymce.init({
      selector: 'textarea',
      plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak',
      toolbar_mode: 'floating',
   });
  
	function ValidateInput(){
		if(document.getElementById("uploadBox").value==""){
			Swal.fire({
			  icon: 'error',
			  title: 'Oops...',
			  text: 'Please upload an Image!',
			});
			return false;
		}
		return true;
	}
	
</script>
<script>
        $(function(){
            $('#datepicker').datepicker({
                changeMonth: true,
                changeYear: true,
                yearRange:"1500:2022"
            })
        })
    </script>
}

LapStore.Web/Areas/Admin/Views/Products/Edit.cshtml
@model Product
@{
    ViewData["Title"] = "Edit";
    Layout = "~/Views/Shared/_LayoutAdmin.cshtml";
}

<form method="post" asp-action="Edit" style="width:90%; margin: 0 auto;" enctype="multipart/form-data">
    <div class="border p-3 mt-4">
        <div class="row pb-6">
            <h2 class="text-primary">Sửa thông tin</h2>
            <hr />
        </div>
        <div asp-validation-summary="ModelOnly" class="text-danger"></div>
        <input type="hidden" asp-for="Id" />
           <div class="mb-3">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="ImageName" class="control-label"></label>
                <input asp-for="ImageName" class="form-control" />
                <span asp-validation-for="ImageName" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="MoreImages" class="control-label"></label>
                <input asp-for="MoreImages" class="form-control" />
                <span asp-validation-for="MoreImages" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="UrlSlug" class="control-label"></label>
                <input asp-for="UrlSlug" disabled class="form-control" />
                <span asp-validation-for="UrlSlug" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Monitor" class="control-label"></label>
                <input asp-for="Monitor" class="form-control" />
                <span asp-validation-for="Monitor" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Cpu" class="control-label"></label>
                <input asp-for="Cpu" class="form-control" />
                <span asp-validation-for="Cpu" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Ram" class="control-label"></label>
                <input asp-for="Ram" class="form-control" />
                <span asp-validation-for="Ram" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="HardDriver" class="control-label"></label>
                <input asp-for="HardDriver" class="form-control" />
                <span asp-validation-for="HardDriver" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Card" class="control-label"></label>
                <input asp-for="Card" class="form-control" />
                <span asp-validation-for="Card" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="OperatingSystem" class="control-label"></label>
                <input asp-for="OperatingSystem" class="form-control" />
                <span asp-validation-for="OperatingSystem" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Weight" class="control-label"></label>
                <input asp-for="Weight" class="form-control" />
                <span asp-validation-for="Weight" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Size" class="control-label"></label>
                <input asp-for="Size" class="form-control" />
                <span asp-validation-for="Size" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="Quantity" class="control-label"></label>
                <input asp-for="Quantity" class="form-control" />
                <span asp-validation-for="Quantity" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="RateCount" class="control-label"></label>
                <input asp-for="RateCount" class="form-control" />
                <span asp-validation-for="RateCount" class="text-danger"></span>
            </div>
            <div class="mb-3">
                <label asp-for="TotalRate" class="control-label"></label>
                <input asp-for="TotalRate" class="form-control" />
                <span asp-validation-for="TotalRate" class="text-danger"></span>
            </div>
		<div class="mb-3">
			<label asp-for="BrandId">Category</label>
			<select asp-for="BrandId" asp-items="@ViewBag.CategoryList" class="form-control">
				<option disabled selected>--Select CoverType--</option>
			</select>
			<span asp-validation-for="BrandId" class="text-danger"></span>
		</div>
        <div class="mb-3">
            <input type="submit" value="Save" class="btn btn-primary" />
        </div>
    </div>
</form>


<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts{
    @{
        <partial name="_ValidationScriptsPartial" />
    }
    <script>
        tinymce.init({
            selector: 'textarea',
            plugins: 'advlist autolink lists link image charmap print preview hr anchor pagebreak',
            toolbar_mode: 'floating',
        });

        function ValidateInput() {
            if (document.getElementById("uploadBox").value == "") {
                Swal.fire({
                    icon: 'error',
                    title: 'Oops...',
                    text: 'Please upload an Image!',
                });
                return false;
            }
            return true;
        }
    </script>
}

LapStore.Web/Areas/Admin/Views/Products/Index.cshtml
@{
    ViewData["Title"] = "";
}
    <div class="container p-3">
        <div class="row pt-4">
            <div class="col-6">
                <h2 class="text-primary">Sản phẩm</h2>
            </div>
            <div class="col-6 text-end">
                <a asp-controller="Products" asp-action="Create" class="btn btn-primary">
                    <i class="bi bi-plus-circle"></i> &nbsp; Thêm mới
                </a>
            </div>
        </div>
        <br /><br />

        <table id="tblData" class="table table-bPostsed table-striped" style="width:100%">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Tên</th>
                    <th>Ảnh</th>
                    <th>Giá</th>
                    <th>Số lượng</th>
                    <th></th>
                </tr>
            </thead>
        </table>
    </div>

@section scripts{
    <script src="~/js/product.js"></script>
}